package de.bsvrz.buv.plugin.darstellung.actions;

import org.eclipse.jface.action.Action;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.widgets.Shell;

import de.bsvrz.buv.plugin.darstellung.dialogs.AnsichtenDialog;
import de.bsvrz.buv.plugin.dobj.internal.DObjPlugin;
import de.bsvrz.sys.funclib.bitctrl.modell.ObjektFactory;

/**
 * ffnet den Dialog mit den globalen Einstellungen fr Ansichten.
 * 
 * @author BitCtrl Systems GmbH, Falko Schumann
 * @version $Id$
 */
public class EditAnsichtenAction extends Action {

	private final Shell parentShell;

	/**
	 * Initialisiert die Aktion.
	 * 
	 * @param parentShell
	 *            die Parent Shell fr Dialoge der Aktion. Darf
	 *            <code>null</code> sein.
	 */
	public EditAnsichtenAction(final Shell parentShell) {
		super("Ansichten bearbeiten", DObjPlugin.getDefault()
				.getImageDescriptor("icons/16x16/actions/ansichten-edit.png"));
		setId(DarstellungActionConstants.EDIT_ANSICHTEN);
		setActionDefinitionId(DarstellungActionConstants.EDIT_ANSICHTEN);

		this.parentShell = parentShell;
	}

	@Override
	public void run() {
		final ObjektFactory nutzerverbindung = DObjPlugin.getDefault()
				.getObjektFactory();
		if (nutzerverbindung.isVerbunden()) {
			final AnsichtenDialog dlg = new AnsichtenDialog(parentShell);
			dlg.open();
		} else {
			MessageDialog.openInformation(parentShell, "Aktion nicht mglich",
					"Es besteht keine Verbindung zum Datenverteiler.");
		}
	}

}
