package de.bsvrz.buv.plugin.darstellung.actions;

import org.eclipse.jface.action.Action;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.widgets.Control;
import org.eclipse.ui.IWorkbenchPart;

import de.bsvrz.buv.plugin.darstellung.dialogs.EbenenWindow;
import de.bsvrz.buv.plugin.darstellung.util.DarstellungIcons;

/**
 * Diese Aktion ffnet und schliet die Legende fr einen Workbench Part.
 * 
 * @author BitCtrl Systems GmbH, Falko Schumann
 * @version $Id$
 */
public class ToggleEbenenAction extends Action {

	private final IWorkbenchPart part;
	private EbenenWindow window;
	private final Control control;

	/**
	 * Initialisiert die Aktion.
	 * 
	 * @param part
	 *            der Workbench Part fr den die Legende gilt.
	 */
	public ToggleEbenenAction(final IWorkbenchPart part, final Control control) {
		super("Ebenen ein-/ausblenden", AS_CHECK_BOX);
		this.part = part;
		this.control = control;

		setImageDescriptor(DarstellungIcons.ActionToggleEbenen
				.getImageDescriptor());
		setToolTipText("Blendet den Ebenenmanager ein und aus.");

		setId(DarstellungActionFactory.TOGGLE_EBENEN.getCommandId());
		setActionDefinitionId(DarstellungActionFactory.TOGGLE_EBENEN
				.getCommandId());
	}

	@Override
	public void run() {
		if (window != null) {
			window.close();
			window = null;
		} else {
			window = new EbenenWindow(part, control);
			window.open();
			window.getShell().addDisposeListener(new DisposeListener() {

				@Override
				public void widgetDisposed(final DisposeEvent e) {
					setChecked(false);
					window = null;
				}

			});
		}
	}

}
