package de.bsvrz.buv.plugin.darstellung.commands;

import org.eclipse.core.runtime.Assert;
import org.eclipse.gef.commands.Command;

import de.bsvrz.buv.plugin.darstellung.model.Ebene;
import de.bsvrz.buv.plugin.dobj.model.DoModel;

public class ChangeIndexOfDoModelCommand extends Command {

	private final Ebene ebene;
	private final int newIndexInEbene;
	private final int oldIndexInEbene;

	public ChangeIndexOfDoModelCommand(final DoModel model, final Ebene ebene,
			final int newIndex) {
		Assert.isNotNull(model, "model");
		Assert.isNotNull(ebene, "ebene");

		this.ebene = ebene;
		oldIndexInEbene = ebene.getDoObjekte().indexOf(model);
		if (newIndex > oldIndexInEbene) {
			newIndexInEbene = newIndex - 1;
		} else {
			newIndexInEbene = newIndex;
		}

		System.out.println(newIndex + " / " + newIndexInEbene);
	}

	@Override
	public boolean canExecute() {
		return oldIndexInEbene != newIndexInEbene && newIndexInEbene >= 0
				&& newIndexInEbene < ebene.getDoObjekte().size();
	}

	@Override
	public void execute() {
		Assert.isTrue(canExecute(), "command is not executable");

		redo();
	}

	@Override
	public void redo() {
		ebene.getDoObjekte().move(newIndexInEbene, oldIndexInEbene);
	}

	@Override
	public void undo() {
		ebene.getDoObjekte().move(oldIndexInEbene, newIndexInEbene);
	}

}
