package de.bsvrz.buv.plugin.darstellung.commands;

import org.eclipse.core.runtime.Assert;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.gef.commands.Command;

import com.bitctrl.lib.eclipse.emf.gef.model.Sized;

import de.bsvrz.buv.plugin.dobj.model.DoModel;

/**
 * Kommando zum ndern der Gre eines Darstellungsobjekts.
 * 
 * @author BitCtrl Systems GmbH, Falko Schumann
 * @version $Id$
 */
public class ResizeDoModelCommand extends Command {

	private final Sized model;
	private final Dimension size;
	private Dimension oldSize;

	public ResizeDoModelCommand(final DoModel model, final Dimension size) {
		Assert.isNotNull(model, "model");
		Assert.isLegal(model instanceof Sized,
				"model muss Sized implementieren");
		Assert.isNotNull(size, "size");

		this.model = (Sized) model;
		this.size = size;

		setLabel("Darstellungsobjekt verschieben");
	}

	@Override
	public void execute() {
		oldSize = model.getSize();

		redo();
	}

	@Override
	public void redo() {
		model.setSize(size);
	}

	@Override
	public void undo() {
		model.setSize(oldSize);
	}

}
