package de.bsvrz.buv.plugin.darstellung.editparts;

import org.eclipse.gef.EditPart;

import de.bsvrz.buv.plugin.darstellung.model.Ansicht;
import de.bsvrz.buv.plugin.darstellung.model.AutoEbene;
import de.bsvrz.buv.plugin.darstellung.model.DarstellungsSpalte;
import de.bsvrz.buv.plugin.darstellung.model.Ebene;
import de.bsvrz.buv.plugin.darstellung.model.MassstaeblicheDarstellung;
import de.bsvrz.buv.plugin.darstellung.model.StilisierteDarstellung;
import de.bsvrz.buv.plugin.dobj.editparts.DoEditPartFactory;

/**
 * Erweitert die Factory aus dem Plug-in <em>Darstellungsobjekte</em> um die
 * Objekte aus dem Plug-in <em>Darstellung</em>.
 * 
 * @author BitCtrl Systems GmbH, Falko Schumann
 * @version $Id$
 */
public class DarstellungEditPartFactory extends DoEditPartFactory {

	@Override
	protected EditPart doCreateEditPart(final EditPart context,
			final Object model) {
		if (model instanceof Ansicht) {
			return new AnsichtEditPart();
		} else if (model instanceof MassstaeblicheDarstellung) {
			return new MassstaeblicheDarstellungEditPart();
		} else if (model instanceof StilisierteDarstellung) {
			return new StilisierteDarstellungEditPart();
		} else if (model instanceof AutoEbene) {
			return new AutoEbeneEditPart();
		} else if (model instanceof Ebene) {
			return new EbeneEditPart();
		} else if (model instanceof DarstellungsSpalte) {
			return new DarstellungsSpalteEditPart();
		}

		return super.doCreateEditPart(context, model);
	}

}
