package de.bsvrz.buv.plugin.darstellung.figures;

import org.eclipse.draw2d.AbstractBackground;
import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.Layer;
import org.eclipse.draw2d.LineBorder;
import org.eclipse.draw2d.XYLayout;

/**
 * Eine Darstellungsspalte wird als Layer mit einem unaufflligen Rahmen
 * gezeichnet.
 * 
 * @author BitCtrl Systems GmbH, Falko Schumann
 * @version $Id$
 */
public class DarstellungsSpalteFigure extends Layer {

	private LineBorder lineBorder;

	{
		setLayoutManager(new XYLayout());

		lineBorder = new LineBorder();
		lineBorder.setColor(ColorConstants.lightGray);
		lineBorder.setStyle(Graphics.LINE_DASH);
	}

	public void showBorder() {
		setBorder(lineBorder);
	}

	public void hideBorder() {
		setBorder(null);
	}

	@Override
	protected void paintFigure(final Graphics graphics) {
		if (getBorder() instanceof AbstractBackground) {
			((AbstractBackground) getBorder()).paintBackground(this, graphics,
					NO_INSETS);
		}
	}

	/**
	 * Darstellungsspalten verwenden lokale Koordinaten, da sie als Layer
	 * nebeneinander anstatt wie sonst bereinander angeordnet werden.
	 */
	@Override
	protected boolean useLocalCoordinates() {
		return true;
	}

}
