package de.bsvrz.buv.plugin.darstellung.internal;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.handlers.HandlerUtil;

import de.bsvrz.buv.plugin.darstellung.actions.DarstellungActionConstants;
import de.bsvrz.buv.plugin.darstellung.actions.EditAnsichtenAction;
import de.bsvrz.buv.plugin.darstellung.actions.ZeigeAnsichtAction;

/**
 * Default Handler fr die Commands dieses Plug-ins.
 * 
 * @author BitCtrl Systems GmbH, Falko Schumann
 * @version $Id$
 */
public class DefaultCommandHandler extends AbstractHandler {

	@Override
	public Object execute(final ExecutionEvent event) throws ExecutionException {
		final Shell shell = HandlerUtil.getActiveShell(event);

		final String commandId = event.getCommand().getId();
		final IWorkbenchPart part = HandlerUtil.getActivePart(event);

		if (DarstellungActionConstants.ZEIGE_ANSICHT.equals(commandId)) {
			new ZeigeAnsichtAction(part).run();
		} else if (DarstellungActionConstants.EDIT_ANSICHTEN.equals(commandId)) {
			new EditAnsichtenAction(shell).run();
		}

		return null;
	}

}
