/**
 * Darstellungsobjekte
 * Copyright (C) 2010 BitCtrl Systems GmbH 
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 * 
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weienfelser Strae 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 *
 * $Id$
 */
package de.bsvrz.buv.plugin.darstellung.model;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc --> The <b>Factory</b> for the model. It provides a
 * create method for each non-abstract class of the model. <!-- end-user-doc -->
 * @see de.bsvrz.buv.plugin.darstellung.model.DarstellungPackage
 * @generated
 */
public interface DarstellungFactory extends EFactory {
	/**
	 * The singleton instance of the factory.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	DarstellungFactory eINSTANCE = de.bsvrz.buv.plugin.darstellung.model.impl.DarstellungFactoryImpl
			.init();

	/**
	 * Returns a new object of class '<em>Ansicht</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Ansicht</em>'.
	 * @generated
	 */
	Ansicht createAnsicht();

	/**
	 * Returns a new object of class '<em>Stilisierte Darstellung</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Stilisierte Darstellung</em>'.
	 * @generated
	 */
	StilisierteDarstellung createStilisierteDarstellung();

	/**
	 * Returns a new object of class '<em>Massstaebliche Darstellung</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Massstaebliche Darstellung</em>'.
	 * @generated
	 */
	MassstaeblicheDarstellung createMassstaeblicheDarstellung();

	/**
	 * Returns a new object of class '<em>Ebene</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Ebene</em>'.
	 * @generated
	 */
	Ebene createEbene();

	/**
	 * Returns a new object of class '<em>Darstellungs Spalte</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Darstellungs Spalte</em>'.
	 * @generated
	 */
	DarstellungsSpalte createDarstellungsSpalte();

	/**
	 * Returns a new object of class '<em>Auto Ebene</em>'.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @return a new object of class '<em>Auto Ebene</em>'.
	 * @generated
	 */
	AutoEbene createAutoEbene();

	/**
	 * Returns a new object of class '<em>Ausschnitt</em>'.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @return a new object of class '<em>Ausschnitt</em>'.
	 * @generated
	 */
	Ausschnitt createAusschnitt();

	/**
	 * Returns the package supported by this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the package supported by this factory.
	 * @generated
	 */
	DarstellungPackage getDarstellungPackage();

} // DarstellungFactory
