/**
 * Darstellungsobjekte
 * Copyright (C) 2010 BitCtrl Systems GmbH 
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 * 
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weienfelser Strae 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 *
 * $Id$
 */
package de.bsvrz.buv.plugin.darstellung.model.impl;

import java.util.Collection;

import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.EMap;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EDataTypeUniqueEList;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EcoreEMap;
import org.eclipse.emf.ecore.util.InternalEList;

import com.bitctrl.lib.eclipse.emf.eclipse.model.EclipsePackage;
import com.bitctrl.lib.eclipse.emf.eclipse.model.impl.NamedImpl;
import com.bitctrl.lib.eclipse.emf.eclipse.model.impl.TupelImpl;
import com.bitctrl.lib.eclipse.emf.gef.model.GefPackage;
import com.bitctrl.lib.eclipse.emf.gef.model.Sized;

import de.bsvrz.buv.plugin.darstellung.model.Darstellung;
import de.bsvrz.buv.plugin.darstellung.model.DarstellungFactory;
import de.bsvrz.buv.plugin.darstellung.model.DarstellungPackage;
import de.bsvrz.buv.plugin.darstellung.model.Ebene;
import de.bsvrz.buv.plugin.dobj.model.DoTyp;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.objekte.Netz;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Darstellung</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link de.bsvrz.buv.plugin.darstellung.model.impl.DarstellungImpl#getSize <em>Size</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.darstellung.model.impl.DarstellungImpl#getDoTypen <em>Do Typen</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.darstellung.model.impl.DarstellungImpl#getEbenen <em>Ebenen</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.darstellung.model.impl.DarstellungImpl#getNetz <em>Netz</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.darstellung.model.impl.DarstellungImpl#getZoomSkalierung <em>Zoom Skalierung</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.darstellung.model.impl.DarstellungImpl#getZoomStufen <em>Zoom Stufen</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.darstellung.model.impl.DarstellungImpl#getProperties <em>Properties</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class DarstellungImpl extends NamedImpl implements Darstellung {
	/**
	 * The default value of the '{@link #getSize() <em>Size</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getSize()
	 * @generated
	 * @ordered
	 */
	protected static final Dimension SIZE_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getSize() <em>Size</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getSize()
	 * @generated
	 * @ordered
	 */
	protected Dimension size = SIZE_EDEFAULT;

	/**
	 * The cached value of the '{@link #getDoTypen() <em>Do Typen</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getDoTypen()
	 * @generated
	 * @ordered
	 */
	protected EList<DoTyp> doTypen;

	/**
	 * The cached value of the '{@link #getEbenen() <em>Ebenen</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getEbenen()
	 * @generated
	 * @ordered
	 */
	protected EList<Ebene> ebenen;

	/**
	 * The default value of the '{@link #getNetz() <em>Netz</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getNetz()
	 * @generated
	 * @ordered
	 */
	protected static final Netz NETZ_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getNetz() <em>Netz</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getNetz()
	 * @generated
	 * @ordered
	 */
	protected Netz netz = NETZ_EDEFAULT;

	/**
	 * The default value of the '{@link #getZoomSkalierung() <em>Zoom Skalierung</em>}' attribute.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see #getZoomSkalierung()
	 * @generated
	 * @ordered
	 */
	protected static final double ZOOM_SKALIERUNG_EDEFAULT = 1.0;

	/**
	 * The cached value of the '{@link #getZoomSkalierung() <em>Zoom Skalierung</em>}' attribute.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see #getZoomSkalierung()
	 * @generated
	 * @ordered
	 */
	protected double zoomSkalierung = ZOOM_SKALIERUNG_EDEFAULT;

	/**
	 * The cached value of the '{@link #getZoomStufen() <em>Zoom Stufen</em>}' attribute list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getZoomStufen()
	 * @generated
	 * @ordered
	 */
	protected EList<Double> zoomStufen;

	/**
	 * The cached value of the '{@link #getProperties() <em>Properties</em>}' map.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getProperties()
	 * @generated
	 * @ordered
	 */
	protected EMap<EObject, EObject> properties;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected DarstellungImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return DarstellungPackage.Literals.DARSTELLUNG;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Dimension getSize() {
		return size;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setSize(Dimension newSize) {
		Dimension oldSize = size;
		size = newSize;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					DarstellungPackage.DARSTELLUNG__SIZE, oldSize, size));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<DoTyp> getDoTypen() {
		if (doTypen == null) {
			doTypen = new EObjectContainmentEList<DoTyp>(DoTyp.class, this,
					DarstellungPackage.DARSTELLUNG__DO_TYPEN);
		}
		return doTypen;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<Ebene> getEbenen() {
		if (ebenen == null) {
			ebenen = new EObjectContainmentWithInverseEList<Ebene>(Ebene.class,
					this, DarstellungPackage.DARSTELLUNG__EBENEN,
					DarstellungPackage.EBENE__DARSTELLUNG);
		}
		return ebenen;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public Netz getNetz() {
		return netz;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void setNetz(Netz newNetz) {
		Netz oldNetz = netz;
		netz = newNetz;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					DarstellungPackage.DARSTELLUNG__NETZ, oldNetz, netz));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public double getZoomSkalierung() {
		return zoomSkalierung;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setZoomSkalierung(double newZoomSkalierung) {
		double oldZoomSkalierung = zoomSkalierung;
		zoomSkalierung = newZoomSkalierung;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					DarstellungPackage.DARSTELLUNG__ZOOM_SKALIERUNG,
					oldZoomSkalierung, zoomSkalierung));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<Double> getZoomStufen() {
		if (zoomStufen == null) {
			zoomStufen = new EDataTypeUniqueEList<Double>(Double.class, this,
					DarstellungPackage.DARSTELLUNG__ZOOM_STUFEN);
		}
		return zoomStufen;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	public EMap<EObject, EObject> getProperties() {
		if (properties == null) {
			properties = new EcoreEMap<EObject, EObject>(
					EclipsePackage.Literals.TUPEL, TupelImpl.class, this,
					DarstellungPackage.DARSTELLUNG__PROPERTIES);
		}
		return properties;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	@Override
	public Ebene createEbene() {
		return DarstellungFactory.eINSTANCE.createEbene();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
		case DarstellungPackage.DARSTELLUNG__EBENEN:
			return ((InternalEList<InternalEObject>) (InternalEList<?>) getEbenen())
					.basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
		case DarstellungPackage.DARSTELLUNG__DO_TYPEN:
			return ((InternalEList<?>) getDoTypen())
					.basicRemove(otherEnd, msgs);
		case DarstellungPackage.DARSTELLUNG__EBENEN:
			return ((InternalEList<?>) getEbenen()).basicRemove(otherEnd, msgs);
		case DarstellungPackage.DARSTELLUNG__PROPERTIES:
			return ((InternalEList<?>) getProperties()).basicRemove(otherEnd,
					msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case DarstellungPackage.DARSTELLUNG__SIZE:
			return getSize();
		case DarstellungPackage.DARSTELLUNG__DO_TYPEN:
			return getDoTypen();
		case DarstellungPackage.DARSTELLUNG__EBENEN:
			return getEbenen();
		case DarstellungPackage.DARSTELLUNG__NETZ:
			return getNetz();
		case DarstellungPackage.DARSTELLUNG__ZOOM_SKALIERUNG:
			return getZoomSkalierung();
		case DarstellungPackage.DARSTELLUNG__ZOOM_STUFEN:
			return getZoomStufen();
		case DarstellungPackage.DARSTELLUNG__PROPERTIES:
			if (coreType)
				return getProperties();
			else
				return getProperties().map();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case DarstellungPackage.DARSTELLUNG__SIZE:
			setSize((Dimension) newValue);
			return;
		case DarstellungPackage.DARSTELLUNG__DO_TYPEN:
			getDoTypen().clear();
			getDoTypen().addAll((Collection<? extends DoTyp>) newValue);
			return;
		case DarstellungPackage.DARSTELLUNG__EBENEN:
			getEbenen().clear();
			getEbenen().addAll((Collection<? extends Ebene>) newValue);
			return;
		case DarstellungPackage.DARSTELLUNG__NETZ:
			setNetz((Netz) newValue);
			return;
		case DarstellungPackage.DARSTELLUNG__ZOOM_SKALIERUNG:
			setZoomSkalierung((Double) newValue);
			return;
		case DarstellungPackage.DARSTELLUNG__ZOOM_STUFEN:
			getZoomStufen().clear();
			getZoomStufen().addAll((Collection<? extends Double>) newValue);
			return;
		case DarstellungPackage.DARSTELLUNG__PROPERTIES:
			((EStructuralFeature.Setting) getProperties()).set(newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case DarstellungPackage.DARSTELLUNG__SIZE:
			setSize(SIZE_EDEFAULT);
			return;
		case DarstellungPackage.DARSTELLUNG__DO_TYPEN:
			getDoTypen().clear();
			return;
		case DarstellungPackage.DARSTELLUNG__EBENEN:
			getEbenen().clear();
			return;
		case DarstellungPackage.DARSTELLUNG__NETZ:
			setNetz(NETZ_EDEFAULT);
			return;
		case DarstellungPackage.DARSTELLUNG__ZOOM_SKALIERUNG:
			setZoomSkalierung(ZOOM_SKALIERUNG_EDEFAULT);
			return;
		case DarstellungPackage.DARSTELLUNG__ZOOM_STUFEN:
			getZoomStufen().clear();
			return;
		case DarstellungPackage.DARSTELLUNG__PROPERTIES:
			getProperties().clear();
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case DarstellungPackage.DARSTELLUNG__SIZE:
			return SIZE_EDEFAULT == null ? size != null : !SIZE_EDEFAULT
					.equals(size);
		case DarstellungPackage.DARSTELLUNG__DO_TYPEN:
			return doTypen != null && !doTypen.isEmpty();
		case DarstellungPackage.DARSTELLUNG__EBENEN:
			return ebenen != null && !ebenen.isEmpty();
		case DarstellungPackage.DARSTELLUNG__NETZ:
			return NETZ_EDEFAULT == null ? netz != null : !NETZ_EDEFAULT
					.equals(netz);
		case DarstellungPackage.DARSTELLUNG__ZOOM_SKALIERUNG:
			return zoomSkalierung != ZOOM_SKALIERUNG_EDEFAULT;
		case DarstellungPackage.DARSTELLUNG__ZOOM_STUFEN:
			return zoomStufen != null && !zoomStufen.isEmpty();
		case DarstellungPackage.DARSTELLUNG__PROPERTIES:
			return properties != null && !properties.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
		if (baseClass == Sized.class) {
			switch (derivedFeatureID) {
			case DarstellungPackage.DARSTELLUNG__SIZE:
				return GefPackage.SIZED__SIZE;
			default:
				return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
		if (baseClass == Sized.class) {
			switch (baseFeatureID) {
			case GefPackage.SIZED__SIZE:
				return DarstellungPackage.DARSTELLUNG__SIZE;
			default:
				return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (size: ");
		result.append(size);
		result.append(", netz: ");
		result.append(netz);
		result.append(", zoomSkalierung: ");
		result.append(zoomSkalierung);
		result.append(", zoomStufen: ");
		result.append(zoomStufen);
		result.append(')');
		return result.toString();
	}

} // DarstellungImpl
