package de.bsvrz.buv.plugin.darstellung.wizards;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchWizard;

/**
 * Implementiert die gemeinsamen Eigenschaften von Import- und Export-Wizards.
 * 
 * @author BitCtrl Systems GmbH, Falko Schumann
 * @version $Id$
 */
public abstract class AbstractWorkbenchWizard extends AbstractWizard implements
		IWorkbenchWizard {

	private IWorkbench workbench;
	private IStructuredSelection selection;

	/**
	 * Initialisiert den Wizard.
	 * 
	 * @param eClass
	 *            die Klasse der zu exportierenden Objekte.
	 */
	protected AbstractWorkbenchWizard(final EClass eClass) {
		super(eClass);
	}

	@Override
	public void init(final IWorkbench w, final IStructuredSelection s) {
		workbench = w;
		selection = s;
	}

	/**
	 * Gibt die Workbench bei der Initialisierung zurck.
	 * 
	 * @see #init(IWorkbench, IStructuredSelection)
	 */
	protected IWorkbench getWorkbench() {
		return workbench;
	}

	/**
	 * Gibt die Selektion bei der Initialisierung zurck.
	 * 
	 * @see #init(IWorkbench, IStructuredSelection)
	 */
	protected IStructuredSelection getSelection() {
		return selection;
	}

}
