package de.bsvrz.buv.plugin.dobj.actions;

import org.eclipse.ui.IWorkbenchPart;

import de.bsvrz.buv.plugin.dobj.tools.PolygonSelectionTool;
import de.bsvrz.buv.plugin.dobj.util.DobjIcons;

/**
 * Action zum Aktivieren des {@link PolygonSelectionTool}.
 * 
 * @author BitCtrl Systems GmbH, Falko Schumann
 * @version $Id$
 */
public class PolygonSelectionAction extends AbstractToolAction {

	/**
	 * Initialsiert die Action.
	 * 
	 * @param part
	 *            der Workbench Part fr den die Action verwendet werden soll.
	 */
	public PolygonSelectionAction(final IWorkbenchPart part) {
		super(part, "Polygonselektion", new PolygonSelectionTool());
		setToolTipText("Polygonselektion");
		setId(DobjActionFactory.SELECTION_POLYGON.getCommandId());
		setActionDefinitionId(DobjActionFactory.SELECTION_POLYGON
				.getCommandId());
		setImageDescriptor(DobjIcons.ActionSelectionPolygon
				.getImageDescriptor());
	}
}
