package de.bsvrz.buv.plugin.dobj.actions;

import org.eclipse.ui.IWorkbenchPart;

import de.bsvrz.buv.plugin.dobj.internal.DobjMessages;
import de.bsvrz.buv.plugin.dobj.tools.RectangleZoomTool;
import de.bsvrz.buv.plugin.dobj.util.DobjIcons;

/**
 * Action zum Aktivieren des {@link RectangleZoomTool}.
 * 
 * @author BitCtrl Systems GmbH, Falko Schumann
 * @version $Id$
 */
public class RectangleZoomAction extends AbstractToolAction {

	/**
	 * Initialsiert die Action.
	 * 
	 * @param part
	 *            der Workbench Part fr den die Action verwendet werden soll.
	 */
	public RectangleZoomAction(final IWorkbenchPart part) {
		super(part, DobjMessages.RectangleZoom_Label, new RectangleZoomTool());
		setToolTipText(DobjMessages.RectangleZoom_Tooltip);
		setId(DobjActionFactory.ZOOM_RECTANGLE.getCommandId());
		setActionDefinitionId(DobjActionFactory.ZOOM_RECTANGLE.getCommandId());
		setImageDescriptor(DobjIcons.ActionZoomRectangle.getImageDescriptor());
	}

}
