package de.bsvrz.buv.plugin.dobj.actions;

import org.eclipse.gef.EditPart;
import org.eclipse.gef.GraphicalViewer;
import org.eclipse.gef.Request;
import org.eclipse.jface.action.IAction;
import org.eclipse.ui.IWorkbenchPart;

import de.bsvrz.buv.plugin.dobj.internal.DobjMessages;
import de.bsvrz.buv.plugin.dobj.requests.KollisionsAlgorithmusRequest;
import de.bsvrz.buv.plugin.dobj.util.DobjIcons;

/**
 * Schaltet den Antikollisionsalgorithmus ein und aus.
 * 
 * @author BitCtrl Systems GmbH, Schumann
 * @version $Id$
 */
public class ToggleAntiKollisionsAlgorithmusAction extends
		DobjWorkbenchPartAction {

	/**
	 * Initialisiert die Action.
	 * 
	 * @param part
	 *            der Workbench Part mit dem die Action arbeiten soll.
	 */
	public ToggleAntiKollisionsAlgorithmusAction(final IWorkbenchPart part) {
		super(part, IAction.AS_CHECK_BOX);

		setText(DobjMessages.ToggleAntiKollisionsAlgorithmus_Label);
		setToolTipText(DobjMessages.ToggleAntiKollisionsAlgorithmus_Tooltip);
		setId(DobjActionFactory.TOGGLE_ANTI_KOLLISIONS_ALGORITHMUS
				.getCommandId());
		setActionDefinitionId(DobjActionFactory.TOGGLE_ANTI_KOLLISIONS_ALGORITHMUS
				.getCommandId());
		setImageDescriptor(DobjIcons.ActionToggleAntikollisionsAlgorithmus
				.getImageDescriptor());
		setChecked(true);
	}

	@Override
	public void run() {
		final GraphicalViewer viewer = getViewer();

		final Request req = new KollisionsAlgorithmusRequest(isChecked());
		for (final Object e : viewer.getEditPartRegistry().values()) {
			final EditPart editPart = (EditPart) e;
			editPart.performRequest(req);
		}
	}

}
