/**
 * Darstellungsobjekte - Decorator
 * Copyright (C) 2012 BitCtrl Systems GmbH 
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 * 
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weienfelser Strae 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */
package de.bsvrz.buv.plugin.dobj.decorator.model;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Linien Style Decorator</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link de.bsvrz.buv.plugin.dobj.decorator.model.LinienStyleDecorator#getStyle <em>Style</em>}</li>
 * </ul>
 * </p>
 *
 * @see de.bsvrz.buv.plugin.dobj.decorator.model.DobjDecoratorPackage#getLinienStyleDecorator()
 * @model interface="true" abstract="true"
 * @generated
 */
public interface LinienStyleDecorator extends EObject {
	/**
	 * Returns the value of the '<em><b>Style</b></em>' attribute.
	 * The default value is <code>"Durchgezogen"</code>.
	 * The literals are from the enumeration {@link de.bsvrz.buv.plugin.dobj.decorator.model.LinienStyle}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Style</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Style</em>' attribute.
	 * @see de.bsvrz.buv.plugin.dobj.decorator.model.LinienStyle
	 * @see #isSetStyle()
	 * @see #unsetStyle()
	 * @see #setStyle(LinienStyle)
	 * @see de.bsvrz.buv.plugin.dobj.decorator.model.DobjDecoratorPackage#getLinienStyleDecorator_Style()
	 * @model default="Durchgezogen" unsettable="true"
	 * @generated
	 */
	LinienStyle getStyle();

	/**
	 * Sets the value of the '{@link de.bsvrz.buv.plugin.dobj.decorator.model.LinienStyleDecorator#getStyle <em>Style</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Style</em>' attribute.
	 * @see de.bsvrz.buv.plugin.dobj.decorator.model.LinienStyle
	 * @see #isSetStyle()
	 * @see #unsetStyle()
	 * @see #getStyle()
	 * @generated
	 */
	void setStyle(LinienStyle value);

	/**
	 * Unsets the value of the '{@link de.bsvrz.buv.plugin.dobj.decorator.model.LinienStyleDecorator#getStyle <em>Style</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetStyle()
	 * @see #getStyle()
	 * @see #setStyle(LinienStyle)
	 * @generated
	 */
	void unsetStyle();

	/**
	 * Returns whether the value of the '{@link de.bsvrz.buv.plugin.dobj.decorator.model.LinienStyleDecorator#getStyle <em>Style</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Style</em>' attribute is set.
	 * @see #unsetStyle()
	 * @see #getStyle()
	 * @see #setStyle(LinienStyle)
	 * @generated
	 */
	boolean isSetStyle();

} // LinienStyleDecorator
