/**
 * 
 */
package de.bsvrz.buv.plugin.dobj.editparts;

import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.draw2d.geometry.Point;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.gef.EditPolicy;

import com.bitctrl.lib.eclipse.emf.gef.model.GefPackage;

import de.bsvrz.buv.plugin.dobj.figures.DoBildFigure;
import de.bsvrz.buv.plugin.dobj.model.DoBild;
import de.bsvrz.buv.plugin.dobj.model.DobjPackage;

/**
 * EditPart fr ein Bild, das als Darstellungsobjekt behandelt wird.
 * 
 * @author BitCtrl Systems GmbH 2010, Christian Hoesel
 * @version $Id$
 */
public class DoBildEditPart extends DoModelEditPart<DoBild, DoBildFigure> {

	@Override
	protected DoBildFigure createFigure() {
		final DoBildFigure result = new DoBildFigure();

		if (!getModel().eIsSet(GefPackage.Literals.SIZED__SIZE)) {
			result.setBounds(new Rectangle(0, 0, 100, 100));
		} else {
			result.setBounds(new Rectangle(new Point(0, 0), getModel()
					.getSize()));
		}
		if (getModel().eIsSet(DobjPackage.Literals.DO_BILD__BILD)) {
			result.setBild(getModel().getBild());
		}

		return result;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see de.bsvrz.buv.plugin.dobj.editparts.DoModelEditPart#getToolTip()
	 */
	@Override
	protected IFigure getToolTip() {
		return null;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * de.bsvrz.buv.plugin.dobj.editparts.DoModelEditPart#createEditPolicies()
	 */
	@Override
	protected void createEditPolicies() {
		super.createEditPolicies();
		if (!isEditor()) {
			removeEditPolicy(EditPolicy.LAYOUT_ROLE);
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * de.bsvrz.buv.plugin.dobj.editparts.DoModelEditPart#notifyChanged(org.
	 * eclipse.emf.common.notify.Notification)
	 */
	@Override
	public void notifyChanged(final Notification notification) {
		super.notifyChanged(notification);
		if (GefPackage.Literals.SIZED__SIZE.equals(notification.getFeature())) {
			if (getModel().getSize() != null) {
				getFigure().setSize(getModel().getSize());
			} else {
				getFigure().setSize(new Dimension(100, 100));
			}
			if (getModel().getBild() != null) {
				getFigure().setBild(getModel().getBild());
			}
		} else if (DobjPackage.Literals.DO_BILD__BILD.equals(notification
				.getFeature())) {
			getFigure().setBild(getModel().getBild());
		}
	}
}
