/**
 * Darstellungsobjekte
 * Copyright (C) 2010 BitCtrl Systems GmbH 
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 * 
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weienfelser Strae 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */
package de.bsvrz.buv.plugin.dobj.model.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.gef.GraphicalEditPart;
import org.eclipse.jface.resource.ImageDescriptor;

import com.bitctrl.lib.eclipse.emf.eclipse.model.impl.NamedImpl;

import de.bsvrz.buv.plugin.dobj.model.DoModel;
import de.bsvrz.buv.plugin.dobj.model.DoTyp;
import de.bsvrz.buv.plugin.dobj.model.DobjPackage;
import de.bsvrz.buv.plugin.dobj.model.ZoomStufe;
import de.bsvrz.dav.daf.main.config.SystemObjectType;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Do Typ</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link de.bsvrz.buv.plugin.dobj.model.impl.DoTypImpl#getId <em>Id</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.dobj.model.impl.DoTypImpl#getDescription <em>Description</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.dobj.model.impl.DoTypImpl#getSystemObjectType <em>System Object Type</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.dobj.model.impl.DoTypImpl#getIcon <em>Icon</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.dobj.model.impl.DoTypImpl#getZoomStufe <em>Zoom Stufe</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class DoTypImpl extends NamedImpl implements DoTyp {
	/**
	 * The default value of the '{@link #getId() <em>Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getId()
	 * @generated
	 * @ordered
	 */
	protected static final String ID_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getId() <em>Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getId()
	 * @generated
	 * @ordered
	 */
	protected String id = ID_EDEFAULT;

	/**
	 * The default value of the '{@link #getDescription() <em>Description</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getDescription()
	 * @generated
	 * @ordered
	 */
	protected static final String DESCRIPTION_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getDescription() <em>Description</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getDescription()
	 * @generated
	 * @ordered
	 */
	protected String description = DESCRIPTION_EDEFAULT;

	/**
	 * The default value of the '{@link #getSystemObjectType() <em>System Object Type</em>}' attribute.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see #getSystemObjectType()
	 * @generated
	 * @ordered
	 */
	protected static final SystemObjectType SYSTEM_OBJECT_TYPE_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getSystemObjectType() <em>System Object Type</em>}' attribute.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see #getSystemObjectType()
	 * @generated
	 * @ordered
	 */
	protected SystemObjectType systemObjectType = SYSTEM_OBJECT_TYPE_EDEFAULT;

	/**
	 * The default value of the '{@link #getIcon() <em>Icon</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getIcon()
	 * @generated
	 * @ordered
	 */
	protected static final ImageDescriptor ICON_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getIcon() <em>Icon</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getIcon()
	 * @generated
	 * @ordered
	 */
	protected ImageDescriptor icon = ICON_EDEFAULT;

	/**
	 * The cached value of the '{@link #getZoomStufe() <em>Zoom Stufe</em>}' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getZoomStufe()
	 * @generated
	 * @ordered
	 */
	protected ZoomStufe zoomStufe;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected DoTypImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return DobjPackage.Literals.DO_TYP;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getId() {
		return id;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setId(String newId) {
		String oldId = id;
		id = newId;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					DobjPackage.DO_TYP__ID, oldId, id));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public String getDescription() {
		return description;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDescription(String newDescription) {
		String oldDescription = description;
		description = newDescription;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					DobjPackage.DO_TYP__DESCRIPTION, oldDescription,
					description));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public SystemObjectType getSystemObjectType() {
		return systemObjectType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSystemObjectType(SystemObjectType newSystemObjectType) {
		SystemObjectType oldSystemObjectType = systemObjectType;
		systemObjectType = newSystemObjectType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					DobjPackage.DO_TYP__SYSTEM_OBJECT_TYPE,
					oldSystemObjectType, systemObjectType));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public ImageDescriptor getIcon() {
		return icon;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setIcon(ImageDescriptor newIcon) {
		ImageDescriptor oldIcon = icon;
		icon = newIcon;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					DobjPackage.DO_TYP__ICON, oldIcon, icon));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public ZoomStufe getZoomStufe() {
		return zoomStufe;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetZoomStufe(ZoomStufe newZoomStufe,
			NotificationChain msgs) {
		ZoomStufe oldZoomStufe = zoomStufe;
		zoomStufe = newZoomStufe;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this,
					Notification.SET, DobjPackage.DO_TYP__ZOOM_STUFE,
					oldZoomStufe, newZoomStufe);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void setZoomStufe(ZoomStufe newZoomStufe) {
		if (newZoomStufe != zoomStufe) {
			NotificationChain msgs = null;
			if (zoomStufe != null)
				msgs = ((InternalEObject) zoomStufe)
						.eInverseRemove(this, EOPPOSITE_FEATURE_BASE
								- DobjPackage.DO_TYP__ZOOM_STUFE, null, msgs);
			if (newZoomStufe != null)
				msgs = ((InternalEObject) newZoomStufe)
						.eInverseAdd(this, EOPPOSITE_FEATURE_BASE
								- DobjPackage.DO_TYP__ZOOM_STUFE, null, msgs);
			msgs = basicSetZoomStufe(newZoomStufe, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					DobjPackage.DO_TYP__ZOOM_STUFE, newZoomStufe, newZoomStufe));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public DoModel createModel() {
		// TODO: implement this method
		// Ensure that you remove @generated or mark it @generated NOT
		throw new UnsupportedOperationException();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public GraphicalEditPart createController() {
		// TODO: implement this method
		// Ensure that you remove @generated or mark it @generated NOT
		throw new UnsupportedOperationException();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
		case DobjPackage.DO_TYP__ZOOM_STUFE:
			return basicSetZoomStufe(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case DobjPackage.DO_TYP__ID:
			return getId();
		case DobjPackage.DO_TYP__DESCRIPTION:
			return getDescription();
		case DobjPackage.DO_TYP__SYSTEM_OBJECT_TYPE:
			return getSystemObjectType();
		case DobjPackage.DO_TYP__ICON:
			return getIcon();
		case DobjPackage.DO_TYP__ZOOM_STUFE:
			return getZoomStufe();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case DobjPackage.DO_TYP__ID:
			setId((String) newValue);
			return;
		case DobjPackage.DO_TYP__DESCRIPTION:
			setDescription((String) newValue);
			return;
		case DobjPackage.DO_TYP__SYSTEM_OBJECT_TYPE:
			setSystemObjectType((SystemObjectType) newValue);
			return;
		case DobjPackage.DO_TYP__ICON:
			setIcon((ImageDescriptor) newValue);
			return;
		case DobjPackage.DO_TYP__ZOOM_STUFE:
			setZoomStufe((ZoomStufe) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case DobjPackage.DO_TYP__ID:
			setId(ID_EDEFAULT);
			return;
		case DobjPackage.DO_TYP__DESCRIPTION:
			setDescription(DESCRIPTION_EDEFAULT);
			return;
		case DobjPackage.DO_TYP__SYSTEM_OBJECT_TYPE:
			setSystemObjectType(SYSTEM_OBJECT_TYPE_EDEFAULT);
			return;
		case DobjPackage.DO_TYP__ICON:
			setIcon(ICON_EDEFAULT);
			return;
		case DobjPackage.DO_TYP__ZOOM_STUFE:
			setZoomStufe((ZoomStufe) null);
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case DobjPackage.DO_TYP__ID:
			return ID_EDEFAULT == null ? id != null : !ID_EDEFAULT.equals(id);
		case DobjPackage.DO_TYP__DESCRIPTION:
			return DESCRIPTION_EDEFAULT == null ? description != null
					: !DESCRIPTION_EDEFAULT.equals(description);
		case DobjPackage.DO_TYP__SYSTEM_OBJECT_TYPE:
			return SYSTEM_OBJECT_TYPE_EDEFAULT == null ? systemObjectType != null
					: !SYSTEM_OBJECT_TYPE_EDEFAULT.equals(systemObjectType);
		case DobjPackage.DO_TYP__ICON:
			return ICON_EDEFAULT == null ? icon != null : !ICON_EDEFAULT
					.equals(icon);
		case DobjPackage.DO_TYP__ZOOM_STUFE:
			return zoomStufe != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (id: ");
		result.append(id);
		result.append(", description: ");
		result.append(description);
		result.append(", systemObjectType: ");
		result.append(systemObjectType);
		result.append(", icon: ");
		result.append(icon);
		result.append(')');
		return result.toString();
	}

} // DoTypImpl
