package de.bsvrz.buv.plugin.dobj.properties;

import org.eclipse.gef.EditPart;
import org.eclipse.ui.views.properties.tabbed.ITypeMapper;

import de.bsvrz.buv.plugin.dobj.model.BitCtrlDoModel;
import de.bsvrz.sys.funclib.bitctrl.modell.SystemObjekt;

/**
 * Allgemeine Implementierung des Interfaces {@link ITypeMapper} fr die
 * Verwendung Tabbed Properties.
 * 
 * @author BitCtrl Systems GmbH, schumann
 * @version $Id$
 */
public class SystemObjektTypeMapper implements ITypeMapper {

	@Override
	public Class<?> mapType(final Object object) {
		final Class<?> type = object.getClass();
		if (object instanceof EditPart) {
			final Object model = ((EditPart) object).getModel();
			if (model instanceof BitCtrlDoModel) {
				final SystemObjekt systemObjekt = ((BitCtrlDoModel<?>) model)
						.getSystemObjekt();
				if (systemObjekt != null) {
					return systemObjekt.getClass();
				}
				return null;
			}
		}
		return type;
	}

}
