package de.bsvrz.buv.plugin.dobj.util;

import org.eclipse.jface.resource.ImageDescriptor;

import de.bsvrz.buv.plugin.dobj.internal.DObjPlugin;

/**
 * Stellt gemeinsam nutzbare Icons zur Verfgung.
 * 
 * @author BitCtrl Systems GmbH, Schumann
 * @version $Id$
 */
public enum DobjIcons {

	// Actions

	/** Schaltflche fr Ausschnitt verschieben. */
	ActionPan("icons/16x16/actions/pan.png"),

	/** Schaltflche fr Ellipseselektion. */
	ActionSelectionEllipse("icons/16x16/actions/selection-ellipse.png"),

	/** Schaltflche fr Polygonselektion. */
	ActionSelectionPolygon("icons/16x16/actions/selection-polygon.png"),

	/** Schaltflche fr Rechteckselektion. */
	ActionSelectionRectangle("icons/16x16/actions/selection-rectangle.png"),

	/** Schaltflche fr Streckenselektion. */
	ActionSelectionStrecke("icons/16x16/actions/selection-strecke.png"),

	/** Schaltflche fr das Aktivieren der Teilselektion. */
	ActionToggleTouchedSelection(
			"icons/16x16/actions/selection-toggle-touched.png"),

	/** Schaltflche fr das Beibehalten des Auschnitts. */
	ActionToggleFixViewport("icons/16x16/actions/fix-viewport.png"),

	/** Schaltflche zum Online-/Offlineschalten einer Darstellung */
	ActionToggleOnline("icons/16x16/actions/toggle-online.png"),

	/** Icon fr Hineinzoomen. */
	ActionZoomIn("icons/16x16/actions/zoom-in.gif"),

	/** Icon fr Hinauszoomen. */
	ActionZoomOut("icons/16x16/actions/zoom-out.gif"),

	/** Schaltflche fr Rechteckzoom. */
	ActionZoomRectangle("icons/16x16/actions/zoom-rectangle.png"),

	/** Schaltflche fr das Wiederherstellen eines Defaultwert. */
	ActionRestoreDefault("icons/16x16/actions/restore-default.gif"),

	/**
	 * Schaltflche zum Ein- und Ausblenden der Verbindungslinien von
	 * verschobenen Objekten zu ihrer Originalposition.
	 */
	ActionToggleVerbindingslinie(
			"icons/16x16/actions/toogle-verbindungslinie.png"),

	/**
	 * Schaltflueche zum Ein- und Ausblenden des Filters fuer <b>alle</b>
	 * gueltige Baustellen.
	 */
	ActionToggleBaustelleGueltig(
			"icons/16x16/actions/toggle-baustellegueltig.png"),

	/**
	 * Schaltflche zum Ein- und Ausblenden der sofortigen Selektion.
	 */
	ActionToggleSelectionFeedback(
			"icons/16x16/actions/toogle-selection-feedback.gif"),

	/**
	 * Schaltflche zum Ein- und Ausschalten des Antikollisionsalgorithmus.
	 */
	ActionToggleAntikollisionsAlgorithmus(
			"icons/16x16/actions/toogle-antikollisionsalgorithmus.png"),

	;

	private final ImageDescriptor imageDescriptor;

	private DobjIcons(final String imagePath) {
		imageDescriptor = DObjPlugin.getDefault().getImageDescriptor(imagePath);
		if (imageDescriptor == null) {
			final String message = "Datei nicht gefunden: " + imagePath;
			DObjPlugin.getDefault().getLogger().error(message);
		}
	}

	/**
	 * Gibt den {@link ImageDescriptor} zurck.
	 */
	public ImageDescriptor getImageDescriptor() {
		return imageDescriptor;
	}

}
