package de.bsvrz.buv.plugin.dobj.util;

import de.bsvrz.dav.daf.main.config.SystemObject;

/**
 * Schnittstelle zu einem Manager, der den letzten vom System empfangenen
 * Datenzeitstempel verwaltet.
 * 
 * @author BitCtrl Systems GmbH, bitcontrol
 * @version $Id$
 */
public interface IDavZeitStempelManager {

	/**
	 * Setzt den letzten empfangenen Datenzeitstempel.
	 * 
	 * @param zeitStempel
	 *            der letzte empfangene Datenzeitstempel.
	 * @param obj
	 *            dast {@link SystemObject}, fuer das der Zeitstempel gesetzt
	 *            wird.
	 */
	public void setLetztenEmpfangenenZeitStempel(final long zeitStempel,
			final SystemObject obj);

}
