/*
 * Rahmenwerk-Plug-in "Darstellungsobjekttyp-Editor"
 * Copyright (C) 2010 BitCtrl Systems GmbH 
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weissenfelser Strasse 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */

package de.bsvrz.buv.plugin.doeditor.model;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc --> The <b>Factory</b> for the model. It provides a
 * create method for each non-abstract class of the model. <!-- end-user-doc -->
 * @see de.bsvrz.buv.plugin.doeditor.model.DoeditorPackage
 * @generated
 */
public interface DoeditorFactory extends EFactory {
	/**
	 * The singleton instance of the factory.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	DoeditorFactory eINSTANCE = de.bsvrz.buv.plugin.doeditor.model.impl.DoeditorFactoryImpl
			.init();

	/**
	 * Returns a new object of class '<em>Bild Form</em>'.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @return a new object of class '<em>Bild Form</em>'.
	 * @generated
	 */
	BildForm createBildForm();

	/**
	 * Returns a new object of class '<em>Text Form</em>'.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @return a new object of class '<em>Text Form</em>'.
	 * @generated
	 */
	TextForm createTextForm();

	/**
	 * Returns a new object of class '<em>Polyline Form</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Polyline Form</em>'.
	 * @generated
	 */
	PolylineForm createPolylineForm();

	/**
	 * Returns a new object of class '<em>Polygon Form</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Polygon Form</em>'.
	 * @generated
	 */
	PolygonForm createPolygonForm();

	/**
	 * Returns a new object of class '<em>Ellipse Form</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Ellipse Form</em>'.
	 * @generated
	 */
	EllipseForm createEllipseForm();

	/**
	 * Returns a new object of class '<em>Rechteck Form</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Rechteck Form</em>'.
	 * @generated
	 */
	RechteckForm createRechteckForm();

	/**
	 * Returns a new object of class '<em>Decorator</em>'.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @return a new object of class '<em>Decorator</em>'.
	 * @generated
	 */
	Decorator createDecorator();

	/**
	 * Returns a new object of class '<em>Zoom Decorator</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Zoom Decorator</em>'.
	 * @generated
	 */
	ZoomDecorator createZoomDecorator();

	/**
	 * Returns a new object of class '<em>Editor Do Model</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Editor Do Model</em>'.
	 * @generated
	 */
	EditorDoModel createEditorDoModel();

	/**
	 * Returns a new object of class '<em>Attribute Text Decorator</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Attribute Text Decorator</em>'.
	 * @generated
	 */
	AttributeTextDecorator createAttributeTextDecorator();

	/**
	 * Returns a new object of class '<em>Background Attribute Interval Decorator</em>'.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @return a new object of class '<em>Background Attribute Interval Decorator</em>'.
	 * @generated
	 */
	BackgroundAttributeIntervalDecorator createBackgroundAttributeIntervalDecorator();

	/**
	 * Returns a new object of class '<em>Background Attribute Text Decorator</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Background Attribute Text Decorator</em>'.
	 * @generated
	 */
	BackgroundAttributeTextDecorator createBackgroundAttributeTextDecorator();

	/**
	 * Returns a new object of class '<em>Background Zoom Decorator</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Background Zoom Decorator</em>'.
	 * @generated
	 */
	BackgroundZoomDecorator createBackgroundZoomDecorator();

	/**
	 * Returns a new object of class '<em>Drehwinkel Attribute Text Decorator</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Drehwinkel Attribute Text Decorator</em>'.
	 * @generated
	 */
	DrehwinkelAttributeTextDecorator createDrehwinkelAttributeTextDecorator();

	/**
	 * Returns a new object of class '<em>Drehwinkel Attribute Interval Decorator</em>'.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @return a new object of class '<em>Drehwinkel Attribute Interval Decorator</em>'.
	 * @generated
	 */
	DrehwinkelAttributeIntervalDecorator createDrehwinkelAttributeIntervalDecorator();

	/**
	 * Returns a new object of class '<em>Drehwinkel Zoom Decorator</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Drehwinkel Zoom Decorator</em>'.
	 * @generated
	 */
	DrehwinkelZoomDecorator createDrehwinkelZoomDecorator();

	/**
	 * Returns a new object of class '<em>Font Data Attribute Interval Decorator</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Font Data Attribute Interval Decorator</em>'.
	 * @generated
	 */
	FontDataAttributeIntervalDecorator createFontDataAttributeIntervalDecorator();

	/**
	 * Returns a new object of class '<em>Font Data Attribute Text Decorator</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Font Data Attribute Text Decorator</em>'.
	 * @generated
	 */
	FontDataAttributeTextDecorator createFontDataAttributeTextDecorator();

	/**
	 * Returns a new object of class '<em>Font Data Zoom Decorator</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Font Data Zoom Decorator</em>'.
	 * @generated
	 */
	FontDataZoomDecorator createFontDataZoomDecorator();

	/**
	 * Returns a new object of class '<em>Foreground Attribute Text Decorator</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Foreground Attribute Text Decorator</em>'.
	 * @generated
	 */
	ForegroundAttributeTextDecorator createForegroundAttributeTextDecorator();

	/**
	 * Returns a new object of class '<em>Foreground Attribute Interval Decorator</em>'.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @return a new object of class '<em>Foreground Attribute Interval Decorator</em>'.
	 * @generated
	 */
	ForegroundAttributeIntervalDecorator createForegroundAttributeIntervalDecorator();

	/**
	 * Returns a new object of class '<em>Foreground Zoom Decorator</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Foreground Zoom Decorator</em>'.
	 * @generated
	 */
	ForegroundZoomDecorator createForegroundZoomDecorator();

	/**
	 * Returns a new object of class '
	 * <em>Line Attribute Attribute Interval Decorator</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '
	 *         <em>Line Attribute Attribute Interval Decorator</em>'.
	 * @generated
	 */
	LineAttributeAttributeIntervalDecorator createLineAttributeAttributeIntervalDecorator();

	/**
	 * Returns a new object of class '<em>Line Attribute Attribute Text Decorator</em>'.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @return a new object of class '<em>Line Attribute Attribute Text Decorator</em>'.
	 * @generated
	 */
	LineAttributeAttributeTextDecorator createLineAttributeAttributeTextDecorator();

	/**
	 * Returns a new object of class '<em>Line Attribute Zoom Decorator</em>'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return a new object of class '<em>Line Attribute Zoom Decorator</em>'.
	 * @generated
	 */
	LineAttributeZoomDecorator createLineAttributeZoomDecorator();

	/**
	 * Returns a new object of class '<em>Sichtbarkeit Attribute Text Decorator</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Sichtbarkeit Attribute Text Decorator</em>'.
	 * @generated
	 */
	SichtbarkeitAttributeTextDecorator createSichtbarkeitAttributeTextDecorator();

	/**
	 * Returns a new object of class '<em>Sichtbarkeit Attribute Interval Decorator</em>'.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @return a new object of class '<em>Sichtbarkeit Attribute Interval Decorator</em>'.
	 * @generated
	 */
	SichtbarkeitAttributeIntervalDecorator createSichtbarkeitAttributeIntervalDecorator();

	/**
	 * Returns a new object of class '<em>Sichtbarkeit Zoom Decorator</em>'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return a new object of class '<em>Sichtbarkeit Zoom Decorator</em>'.
	 * @generated
	 */
	SichtbarkeitZoomDecorator createSichtbarkeitZoomDecorator();

	/**
	 * Returns a new object of class '<em>String Attribute Interval Decorator</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>String Attribute Interval Decorator</em>'.
	 * @generated
	 */
	StringAttributeIntervalDecorator createStringAttributeIntervalDecorator();

	/**
	 * Returns a new object of class '<em>String Attribute Text Decorator</em>'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return a new object of class '<em>String Attribute Text Decorator</em>'.
	 * @generated
	 */
	StringAttributeTextDecorator createStringAttributeTextDecorator();

	/**
	 * Returns a new object of class '<em>String Zoom Decorator</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>String Zoom Decorator</em>'.
	 * @generated
	 */
	StringZoomDecorator createStringZoomDecorator();

	/**
	 * Returns a new object of class '
	 * <em>Zoom Verhalten Attribute Interval Decorator</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '
	 *         <em>Zoom Verhalten Attribute Interval Decorator</em>'.
	 * @generated
	 */
	ZoomVerhaltenAttributeIntervalDecorator createZoomVerhaltenAttributeIntervalDecorator();

	/**
	 * Returns a new object of class '<em>Zoom Verhalten Attribute Text Decorator</em>'.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @return a new object of class '<em>Zoom Verhalten Attribute Text Decorator</em>'.
	 * @generated
	 */
	ZoomVerhaltenAttributeTextDecorator createZoomVerhaltenAttributeTextDecorator();

	/**
	 * Returns a new object of class '<em>Zoom Verhalten Zoom Decorator</em>'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return a new object of class '<em>Zoom Verhalten Zoom Decorator</em>'.
	 * @generated
	 */
	ZoomVerhaltenZoomDecorator createZoomVerhaltenZoomDecorator();

	/**
	 * Returns a new object of class '<em>Embedded Do Form</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Embedded Do Form</em>'.
	 * @generated
	 */
	EmbeddedDoForm createEmbeddedDoForm();

	/**
	 * Returns a new object of class '<em>External Do Form</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>External Do Form</em>'.
	 * @generated
	 */
	ExternalDoForm createExternalDoForm();

	/**
	 * Returns a new object of class '<em>Do Editor Diagramm</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Do Editor Diagramm</em>'.
	 * @generated
	 */
	DoEditorDiagramm createDoEditorDiagramm();

	/**
	 * Returns a new object of class '<em>Editor Do Typ</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Editor Do Typ</em>'.
	 * @generated
	 */
	EditorDoTyp createEditorDoTyp();

	/**
	 * Returns a new object of class '<em>Editor Do Typ Referenz</em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return a new object of class '<em>Editor Do Typ Referenz</em>'.
	 * @generated
	 */
	EditorDoTypReferenz createEditorDoTypReferenz();

	/**
	 * Returns a new object of class '<em>Border Color Attribute Text Decorator</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Border Color Attribute Text Decorator</em>'.
	 * @generated
	 */
	BorderColorAttributeTextDecorator createBorderColorAttributeTextDecorator();

	/**
	 * Returns a new object of class '<em>Border Color Attribute Interval Decorator</em>'.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @return a new object of class '<em>Border Color Attribute Interval Decorator</em>'.
	 * @generated
	 */
	BorderColorAttributeIntervalDecorator createBorderColorAttributeIntervalDecorator();

	/**
	 * Returns a new object of class '<em>Border Color Zoom Decorator</em>'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return a new object of class '<em>Border Color Zoom Decorator</em>'.
	 * @generated
	 */
	BorderColorZoomDecorator createBorderColorZoomDecorator();

	/**
	 * Returns a new object of class '<em>Border Width Attribute Text Decorator</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Border Width Attribute Text Decorator</em>'.
	 * @generated
	 */
	BorderWidthAttributeTextDecorator createBorderWidthAttributeTextDecorator();

	/**
	 * Returns a new object of class '<em>Border Width Attribute Interval Decorator</em>'.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @return a new object of class '<em>Border Width Attribute Interval Decorator</em>'.
	 * @generated
	 */
	BorderWidthAttributeIntervalDecorator createBorderWidthAttributeIntervalDecorator();

	/**
	 * Returns a new object of class '<em>Border Width Zoom Decorator</em>'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return a new object of class '<em>Border Width Zoom Decorator</em>'.
	 * @generated
	 */
	BorderWidthZoomDecorator createBorderWidthZoomDecorator();

	/**
	 * Returns a new object of class '<em>Identidy</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Identidy</em>'.
	 * @generated
	 */
	Identidy createIdentidy();

	/**
	 * Returns the package supported by this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the package supported by this factory.
	 * @generated
	 */
	DoeditorPackage getDoeditorPackage();

} // DoeditorFactory
