/*
 * Rahmenwerk-Plug-in "Darstellungsobjekttyp-Editor"
 * Copyright (C) 2010 BitCtrl Systems GmbH 
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weissenfelser Strasse 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */

package de.bsvrz.buv.plugin.doeditor.model;

import com.bitctrl.lib.eclipse.emf.eclipse.model.EColor;
import com.bitctrl.lib.eclipse.emf.gef.model.Sized;

import de.bsvrz.sys.funclib.bitctrl.modell.bitctrlallgemein.objekte.PortableBitMap;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Flaechen Form</b></em>'. <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link de.bsvrz.buv.plugin.doeditor.model.FlaechenForm#getBackgroundPattern <em>Background Pattern</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.doeditor.model.FlaechenForm#isFilled <em>Filled</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.doeditor.model.FlaechenForm#getBackgroundColor <em>Background Color</em>}</li>
 * </ul>
 * </p>
 *
 * @see de.bsvrz.buv.plugin.doeditor.model.DoeditorPackage#getFlaechenForm()
 * @model abstract="true"
 * @generated
 */
public interface FlaechenForm extends LinienForm, Sized {
	/**
	 * Returns the value of the '<em><b>Background Color</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Background Color</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Background Color</em>' containment reference.
	 * @see #setBackgroundColor(EColor)
	 * @see de.bsvrz.buv.plugin.doeditor.model.DoeditorPackage#getFlaechenForm_BackgroundColor()
	 * @model containment="true"
	 * @generated
	 */
	EColor getBackgroundColor();

	/**
	 * Sets the value of the '{@link de.bsvrz.buv.plugin.doeditor.model.FlaechenForm#getBackgroundColor <em>Background Color</em>}' containment reference.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Background Color</em>' containment reference.
	 * @see #getBackgroundColor()
	 * @generated
	 */
	void setBackgroundColor(EColor value);

	/**
	 * Returns the value of the '<em><b>Background Pattern</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Background Pattern</em>' attribute isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Background Pattern</em>' attribute.
	 * @see #setBackgroundPattern(PortableBitMap)
	 * @see de.bsvrz.buv.plugin.doeditor.model.DoeditorPackage#getFlaechenForm_BackgroundPattern()
	 * @model dataType="com.bitctrl.lib.eclipse.emf.davbitctrl.model.PortableBitmap"
	 * @generated
	 */
	PortableBitMap getBackgroundPattern();

	/**
	 * Sets the value of the '{@link de.bsvrz.buv.plugin.doeditor.model.FlaechenForm#getBackgroundPattern <em>Background Pattern</em>}' attribute.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @param value the new value of the '<em>Background Pattern</em>' attribute.
	 * @see #getBackgroundPattern()
	 * @generated
	 */
	void setBackgroundPattern(PortableBitMap value);

	/**
	 * Returns the value of the '<em><b>Filled</b></em>' attribute.
	 * The default value is <code>"true"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Filled</em>' attribute isn't clear, there
	 * really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Filled</em>' attribute.
	 * @see #setFilled(boolean)
	 * @see de.bsvrz.buv.plugin.doeditor.model.DoeditorPackage#getFlaechenForm_Filled()
	 * @model default="true"
	 * @generated
	 */
	boolean isFilled();

	/**
	 * Sets the value of the '
	 * {@link de.bsvrz.buv.plugin.doeditor.model.FlaechenForm#isFilled
	 * <em>Filled</em>}' attribute. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @param value
	 *            the new value of the '<em>Filled</em>' attribute.
	 * @see #isFilled()
	 * @generated
	 */
	void setFilled(boolean value);

} // FlaechenForm
