/**
 * Rahmenwerk-Plug-in "Darstellungsobjekte"
 * Copyright (C) 2010 BitCtrl Systems GmbH 
 *  
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 * 
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weissenfelser Strasse 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 * 
 * 
 */
package de.bsvrz.buv.plugin.doeditor.model;

import org.eclipse.emf.common.util.EList;

import com.bitctrl.lib.eclipse.emf.eclipse.model.Named;
import com.bitctrl.lib.eclipse.emf.gef.model.Located;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Visible Form</b></em>'. <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link de.bsvrz.buv.plugin.doeditor.model.VisibleForm#getEditorDoTyp <em>Editor Do Typ</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.doeditor.model.VisibleForm#isVisible <em>Visible</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.doeditor.model.VisibleForm#getDecorators <em>Decorators</em>}</li>
 * </ul>
 * </p>
 *
 * @see de.bsvrz.buv.plugin.doeditor.model.DoeditorPackage#getVisibleForm()
 * @model interface="true" abstract="true"
 * @generated
 */
public interface VisibleForm extends Named, Located {
	/**
	 * Returns the value of the '<em><b>Editor Do Typ</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link de.bsvrz.buv.plugin.doeditor.model.EditorDoTyp#getFormen <em>Formen</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Editor Do Typ</em>' container reference isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Editor Do Typ</em>' container reference.
	 * @see #setEditorDoTyp(EditorDoTyp)
	 * @see de.bsvrz.buv.plugin.doeditor.model.DoeditorPackage#getVisibleForm_EditorDoTyp()
	 * @see de.bsvrz.buv.plugin.doeditor.model.EditorDoTyp#getFormen
	 * @model opposite="formen" required="true" transient="false"
	 * @generated
	 */
	EditorDoTyp getEditorDoTyp();

	/**
	 * Sets the value of the '{@link de.bsvrz.buv.plugin.doeditor.model.VisibleForm#getEditorDoTyp <em>Editor Do Typ</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Editor Do Typ</em>' container reference.
	 * @see #getEditorDoTyp()
	 * @generated
	 */
	void setEditorDoTyp(EditorDoTyp value);

	/**
	 * Returns the value of the '<em><b>Visible</b></em>' attribute.
	 * The default value is <code>"true"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Visible</em>' attribute isn't clear, there
	 * really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Visible</em>' attribute.
	 * @see #setVisible(boolean)
	 * @see de.bsvrz.buv.plugin.doeditor.model.DoeditorPackage#getVisibleForm_Visible()
	 * @model default="true"
	 * @generated
	 */
	boolean isVisible();

	/**
	 * Sets the value of the '
	 * {@link de.bsvrz.buv.plugin.doeditor.model.VisibleForm#isVisible
	 * <em>Visible</em>}' attribute. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @param value
	 *            the new value of the '<em>Visible</em>' attribute.
	 * @see #isVisible()
	 * @generated
	 */
	void setVisible(boolean value);

	/**
	 * Returns the value of the '<em><b>Decorators</b></em>' containment reference list.
	 * The list contents are of type {@link de.bsvrz.buv.plugin.doeditor.model.Decorator}.
	 * <!-- begin-user-doc
	 * -->
	 * <p>
	 * If the meaning of the '<em>Decorators</em>' containment reference list
	 * isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Decorators</em>' containment reference list.
	 * @see de.bsvrz.buv.plugin.doeditor.model.DoeditorPackage#getVisibleForm_Decorators()
	 * @model containment="true"
	 * @generated
	 */
	EList<Decorator> getDecorators();

} // VisibleForm
