/*
 * Rahmenwerk-Plug-in "Darstellungsobjekttyp-Editor"
 * Copyright (C) 2010 BitCtrl Systems GmbH 
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weissenfelser Strasse 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */

package de.bsvrz.buv.plugin.doeditor.model.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

import com.bitctrl.lib.eclipse.emf.eclipse.model.EColor;

import de.bsvrz.buv.plugin.doeditor.model.AttributeDecorator;
import de.bsvrz.buv.plugin.doeditor.model.AttributeTextDecorator;
import de.bsvrz.buv.plugin.doeditor.model.Decorator;
import de.bsvrz.buv.plugin.doeditor.model.DoeditorPackage;
import de.bsvrz.buv.plugin.doeditor.model.ForegroundAttributeTextDecorator;
import de.bsvrz.buv.plugin.doeditor.model.TextDecorator;
import de.bsvrz.dav.daf.main.config.Aspect;
import de.bsvrz.dav.daf.main.config.AttributeGroup;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Foreground Attribute Text Decorator</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link de.bsvrz.buv.plugin.doeditor.model.impl.ForegroundAttributeTextDecoratorImpl#getStartColor <em>Start Color</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.doeditor.model.impl.ForegroundAttributeTextDecoratorImpl#getEndColor <em>End Color</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.doeditor.model.impl.ForegroundAttributeTextDecoratorImpl#getText <em>Text</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.doeditor.model.impl.ForegroundAttributeTextDecoratorImpl#getAttributGruppe <em>Attribut Gruppe</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.doeditor.model.impl.ForegroundAttributeTextDecoratorImpl#getAspekt <em>Aspekt</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.doeditor.model.impl.ForegroundAttributeTextDecoratorImpl#getAttributPfad <em>Attribut Pfad</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ForegroundAttributeTextDecoratorImpl extends EObjectImpl implements
		ForegroundAttributeTextDecorator {
	/**
	 * The cached value of the '{@link #getStartColor() <em>Start Color</em>}' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getStartColor()
	 * @generated
	 * @ordered
	 */
	protected EColor startColor;

	/**
	 * The cached value of the '{@link #getEndColor() <em>End Color</em>}' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getEndColor()
	 * @generated
	 * @ordered
	 */
	protected EColor endColor;

	/**
	 * The default value of the '{@link #getText() <em>Text</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getText()
	 * @generated
	 * @ordered
	 */
	protected static final String TEXT_EDEFAULT = "";

	/**
	 * The cached value of the '{@link #getText() <em>Text</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getText()
	 * @generated
	 * @ordered
	 */
	protected String text = TEXT_EDEFAULT;

	/**
	 * The default value of the '{@link #getAttributGruppe() <em>Attribut Gruppe</em>}' attribute.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see #getAttributGruppe()
	 * @generated
	 * @ordered
	 */
	protected static final AttributeGroup ATTRIBUT_GRUPPE_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getAttributGruppe() <em>Attribut Gruppe</em>}' attribute.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see #getAttributGruppe()
	 * @generated
	 * @ordered
	 */
	protected AttributeGroup attributGruppe = ATTRIBUT_GRUPPE_EDEFAULT;

	/**
	 * The default value of the '{@link #getAspekt() <em>Aspekt</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getAspekt()
	 * @generated
	 * @ordered
	 */
	protected static final Aspect ASPEKT_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getAspekt() <em>Aspekt</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getAspekt()
	 * @generated
	 * @ordered
	 */
	protected Aspect aspekt = ASPEKT_EDEFAULT;

	/**
	 * The default value of the '{@link #getAttributPfad() <em>Attribut Pfad</em>}' attribute.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see #getAttributPfad()
	 * @generated
	 * @ordered
	 */
	protected static final String ATTRIBUT_PFAD_EDEFAULT = "";

	/**
	 * The cached value of the '{@link #getAttributPfad() <em>Attribut Pfad</em>}' attribute.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see #getAttributPfad()
	 * @generated
	 * @ordered
	 */
	protected String attributPfad = ATTRIBUT_PFAD_EDEFAULT;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected ForegroundAttributeTextDecoratorImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return DoeditorPackage.Literals.FOREGROUND_ATTRIBUTE_TEXT_DECORATOR;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public EColor getStartColor() {
		return startColor;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetStartColor(EColor newStartColor,
			NotificationChain msgs) {
		EColor oldStartColor = startColor;
		startColor = newStartColor;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(
					this,
					Notification.SET,
					DoeditorPackage.FOREGROUND_ATTRIBUTE_TEXT_DECORATOR__START_COLOR,
					oldStartColor, newStartColor);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void setStartColor(EColor newStartColor) {
		if (newStartColor != startColor) {
			NotificationChain msgs = null;
			if (startColor != null)
				msgs = ((InternalEObject) startColor)
						.eInverseRemove(
								this,
								EOPPOSITE_FEATURE_BASE
										- DoeditorPackage.FOREGROUND_ATTRIBUTE_TEXT_DECORATOR__START_COLOR,
								null, msgs);
			if (newStartColor != null)
				msgs = ((InternalEObject) newStartColor)
						.eInverseAdd(
								this,
								EOPPOSITE_FEATURE_BASE
										- DoeditorPackage.FOREGROUND_ATTRIBUTE_TEXT_DECORATOR__START_COLOR,
								null, msgs);
			msgs = basicSetStartColor(newStartColor, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(
					this,
					Notification.SET,
					DoeditorPackage.FOREGROUND_ATTRIBUTE_TEXT_DECORATOR__START_COLOR,
					newStartColor, newStartColor));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public EColor getEndColor() {
		return endColor;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetEndColor(EColor newEndColor,
			NotificationChain msgs) {
		EColor oldEndColor = endColor;
		endColor = newEndColor;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(
					this,
					Notification.SET,
					DoeditorPackage.FOREGROUND_ATTRIBUTE_TEXT_DECORATOR__END_COLOR,
					oldEndColor, newEndColor);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void setEndColor(EColor newEndColor) {
		if (newEndColor != endColor) {
			NotificationChain msgs = null;
			if (endColor != null)
				msgs = ((InternalEObject) endColor)
						.eInverseRemove(
								this,
								EOPPOSITE_FEATURE_BASE
										- DoeditorPackage.FOREGROUND_ATTRIBUTE_TEXT_DECORATOR__END_COLOR,
								null, msgs);
			if (newEndColor != null)
				msgs = ((InternalEObject) newEndColor)
						.eInverseAdd(
								this,
								EOPPOSITE_FEATURE_BASE
										- DoeditorPackage.FOREGROUND_ATTRIBUTE_TEXT_DECORATOR__END_COLOR,
								null, msgs);
			msgs = basicSetEndColor(newEndColor, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(
					this,
					Notification.SET,
					DoeditorPackage.FOREGROUND_ATTRIBUTE_TEXT_DECORATOR__END_COLOR,
					newEndColor, newEndColor));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getText() {
		return text;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setText(String newText) {
		String oldText = text;
		text = newText;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					DoeditorPackage.FOREGROUND_ATTRIBUTE_TEXT_DECORATOR__TEXT,
					oldText, text));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public AttributeGroup getAttributGruppe() {
		return attributGruppe;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setAttributGruppe(AttributeGroup newAttributGruppe) {
		AttributeGroup oldAttributGruppe = attributGruppe;
		attributGruppe = newAttributGruppe;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(
					this,
					Notification.SET,
					DoeditorPackage.FOREGROUND_ATTRIBUTE_TEXT_DECORATOR__ATTRIBUT_GRUPPE,
					oldAttributGruppe, attributGruppe));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Aspect getAspekt() {
		return aspekt;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setAspekt(Aspect newAspekt) {
		Aspect oldAspekt = aspekt;
		aspekt = newAspekt;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(
					this,
					Notification.SET,
					DoeditorPackage.FOREGROUND_ATTRIBUTE_TEXT_DECORATOR__ASPEKT,
					oldAspekt, aspekt));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getAttributPfad() {
		return attributPfad;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setAttributPfad(String newAttributPfad) {
		String oldAttributPfad = attributPfad;
		attributPfad = newAttributPfad;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(
					this,
					Notification.SET,
					DoeditorPackage.FOREGROUND_ATTRIBUTE_TEXT_DECORATOR__ATTRIBUT_PFAD,
					oldAttributPfad, attributPfad));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
		case DoeditorPackage.FOREGROUND_ATTRIBUTE_TEXT_DECORATOR__START_COLOR:
			return basicSetStartColor(null, msgs);
		case DoeditorPackage.FOREGROUND_ATTRIBUTE_TEXT_DECORATOR__END_COLOR:
			return basicSetEndColor(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case DoeditorPackage.FOREGROUND_ATTRIBUTE_TEXT_DECORATOR__START_COLOR:
			return getStartColor();
		case DoeditorPackage.FOREGROUND_ATTRIBUTE_TEXT_DECORATOR__END_COLOR:
			return getEndColor();
		case DoeditorPackage.FOREGROUND_ATTRIBUTE_TEXT_DECORATOR__TEXT:
			return getText();
		case DoeditorPackage.FOREGROUND_ATTRIBUTE_TEXT_DECORATOR__ATTRIBUT_GRUPPE:
			return getAttributGruppe();
		case DoeditorPackage.FOREGROUND_ATTRIBUTE_TEXT_DECORATOR__ASPEKT:
			return getAspekt();
		case DoeditorPackage.FOREGROUND_ATTRIBUTE_TEXT_DECORATOR__ATTRIBUT_PFAD:
			return getAttributPfad();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case DoeditorPackage.FOREGROUND_ATTRIBUTE_TEXT_DECORATOR__START_COLOR:
			setStartColor((EColor) newValue);
			return;
		case DoeditorPackage.FOREGROUND_ATTRIBUTE_TEXT_DECORATOR__END_COLOR:
			setEndColor((EColor) newValue);
			return;
		case DoeditorPackage.FOREGROUND_ATTRIBUTE_TEXT_DECORATOR__TEXT:
			setText((String) newValue);
			return;
		case DoeditorPackage.FOREGROUND_ATTRIBUTE_TEXT_DECORATOR__ATTRIBUT_GRUPPE:
			setAttributGruppe((AttributeGroup) newValue);
			return;
		case DoeditorPackage.FOREGROUND_ATTRIBUTE_TEXT_DECORATOR__ASPEKT:
			setAspekt((Aspect) newValue);
			return;
		case DoeditorPackage.FOREGROUND_ATTRIBUTE_TEXT_DECORATOR__ATTRIBUT_PFAD:
			setAttributPfad((String) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case DoeditorPackage.FOREGROUND_ATTRIBUTE_TEXT_DECORATOR__START_COLOR:
			setStartColor((EColor) null);
			return;
		case DoeditorPackage.FOREGROUND_ATTRIBUTE_TEXT_DECORATOR__END_COLOR:
			setEndColor((EColor) null);
			return;
		case DoeditorPackage.FOREGROUND_ATTRIBUTE_TEXT_DECORATOR__TEXT:
			setText(TEXT_EDEFAULT);
			return;
		case DoeditorPackage.FOREGROUND_ATTRIBUTE_TEXT_DECORATOR__ATTRIBUT_GRUPPE:
			setAttributGruppe(ATTRIBUT_GRUPPE_EDEFAULT);
			return;
		case DoeditorPackage.FOREGROUND_ATTRIBUTE_TEXT_DECORATOR__ASPEKT:
			setAspekt(ASPEKT_EDEFAULT);
			return;
		case DoeditorPackage.FOREGROUND_ATTRIBUTE_TEXT_DECORATOR__ATTRIBUT_PFAD:
			setAttributPfad(ATTRIBUT_PFAD_EDEFAULT);
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case DoeditorPackage.FOREGROUND_ATTRIBUTE_TEXT_DECORATOR__START_COLOR:
			return startColor != null;
		case DoeditorPackage.FOREGROUND_ATTRIBUTE_TEXT_DECORATOR__END_COLOR:
			return endColor != null;
		case DoeditorPackage.FOREGROUND_ATTRIBUTE_TEXT_DECORATOR__TEXT:
			return TEXT_EDEFAULT == null ? text != null : !TEXT_EDEFAULT
					.equals(text);
		case DoeditorPackage.FOREGROUND_ATTRIBUTE_TEXT_DECORATOR__ATTRIBUT_GRUPPE:
			return ATTRIBUT_GRUPPE_EDEFAULT == null ? attributGruppe != null
					: !ATTRIBUT_GRUPPE_EDEFAULT.equals(attributGruppe);
		case DoeditorPackage.FOREGROUND_ATTRIBUTE_TEXT_DECORATOR__ASPEKT:
			return ASPEKT_EDEFAULT == null ? aspekt != null : !ASPEKT_EDEFAULT
					.equals(aspekt);
		case DoeditorPackage.FOREGROUND_ATTRIBUTE_TEXT_DECORATOR__ATTRIBUT_PFAD:
			return ATTRIBUT_PFAD_EDEFAULT == null ? attributPfad != null
					: !ATTRIBUT_PFAD_EDEFAULT.equals(attributPfad);
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
		if (baseClass == Decorator.class) {
			switch (derivedFeatureID) {
			default:
				return -1;
			}
		}
		if (baseClass == TextDecorator.class) {
			switch (derivedFeatureID) {
			case DoeditorPackage.FOREGROUND_ATTRIBUTE_TEXT_DECORATOR__TEXT:
				return DoeditorPackage.TEXT_DECORATOR__TEXT;
			default:
				return -1;
			}
		}
		if (baseClass == AttributeDecorator.class) {
			switch (derivedFeatureID) {
			case DoeditorPackage.FOREGROUND_ATTRIBUTE_TEXT_DECORATOR__ATTRIBUT_GRUPPE:
				return DoeditorPackage.ATTRIBUTE_DECORATOR__ATTRIBUT_GRUPPE;
			case DoeditorPackage.FOREGROUND_ATTRIBUTE_TEXT_DECORATOR__ASPEKT:
				return DoeditorPackage.ATTRIBUTE_DECORATOR__ASPEKT;
			case DoeditorPackage.FOREGROUND_ATTRIBUTE_TEXT_DECORATOR__ATTRIBUT_PFAD:
				return DoeditorPackage.ATTRIBUTE_DECORATOR__ATTRIBUT_PFAD;
			default:
				return -1;
			}
		}
		if (baseClass == AttributeTextDecorator.class) {
			switch (derivedFeatureID) {
			default:
				return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
		if (baseClass == Decorator.class) {
			switch (baseFeatureID) {
			default:
				return -1;
			}
		}
		if (baseClass == TextDecorator.class) {
			switch (baseFeatureID) {
			case DoeditorPackage.TEXT_DECORATOR__TEXT:
				return DoeditorPackage.FOREGROUND_ATTRIBUTE_TEXT_DECORATOR__TEXT;
			default:
				return -1;
			}
		}
		if (baseClass == AttributeDecorator.class) {
			switch (baseFeatureID) {
			case DoeditorPackage.ATTRIBUTE_DECORATOR__ATTRIBUT_GRUPPE:
				return DoeditorPackage.FOREGROUND_ATTRIBUTE_TEXT_DECORATOR__ATTRIBUT_GRUPPE;
			case DoeditorPackage.ATTRIBUTE_DECORATOR__ASPEKT:
				return DoeditorPackage.FOREGROUND_ATTRIBUTE_TEXT_DECORATOR__ASPEKT;
			case DoeditorPackage.ATTRIBUTE_DECORATOR__ATTRIBUT_PFAD:
				return DoeditorPackage.FOREGROUND_ATTRIBUTE_TEXT_DECORATOR__ATTRIBUT_PFAD;
			default:
				return -1;
			}
		}
		if (baseClass == AttributeTextDecorator.class) {
			switch (baseFeatureID) {
			default:
				return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (text: ");
		result.append(text);
		result.append(", attributGruppe: ");
		result.append(attributGruppe);
		result.append(", aspekt: ");
		result.append(aspekt);
		result.append(", attributPfad: ");
		result.append(attributPfad);
		result.append(')');
		return result.toString();
	}

} // ForegroundAttributeTextDecoratorImpl
